﻿"""
tranforme_chiffre(x) tranforme un chiffre x en un autre.
Le tranforme_chiffre ci-dessous transforme un chiffre en son carré
"""
def transforme_chiffre(x):
    return x*+x+x*x*x

"""
nombre_en_tableau(N) tranforme un entier N comme 3456 en la liste [6,5,4,3]
"""
def nombre_en_tableau(N):
    liste=[]
    while N != 0:
        liste.append(N % 10)
        # reste division N par 10
        N=(N - N % 10) // 10
        # quotient division N par 10
    return liste

"""
sommespeciale(liste) renvoie la somme des chiffres, ou la somme des carrés
des  chiffres, ..., selon la fonction tranforme_chiffre
"""
def sommespeciale(liste,f):
    somme=0
    for i in range(0,len(liste)):
        somme=somme+f(liste[i])
    return somme

"""
A un entier donné, on applique la fonction sommespeciale autant de fois que
nécessaire pour tomber sur 1 ou pour tomber sur un cycle.
sommefinale renvoie alors le cycle obtenu.
Par exemple avec tranforme_chiffre(x)=x^2
    2   ==>   [2, 4, 16, 37, 58, 89, 145, 42, 20, 4]
    7   ==>   [7, 49, 97, 130, 10, 1]
"""
def sommefinale(unentier,f):
    suite=[]
    while (unentier>1) and not(unentier in suite):
        suite.append(unentier)
        unentier=sommespeciale(nombre_en_tableau(unentier),f)
    if (unentier==1):
        suite.append(1)
    else:
        suite.append(unentier)
    return suite

"""
    renvoie le cycle
"""
def cycle(u0,f):
    if (u0<=0):
        return
    return(sommefinale(u0,f))

"""
    renvoie le cycle pour chaque entier compris entre 1 et max
"""
def Cycles(max,f):
    for entier in range(1,max+1):
        print(entier,"  ==>  ",cycle(entier,f))

